// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.22.0

package generated

import (
	"context"
	"database/sql"
	"fmt"
)

type DBTX interface {
	ExecContext(context.Context, string, ...interface{}) (sql.Result, error)
	PrepareContext(context.Context, string) (*sql.Stmt, error)
	QueryContext(context.Context, string, ...interface{}) (*sql.Rows, error)
	QueryRowContext(context.Context, string, ...interface{}) *sql.Row
}

func New(db DBTX) *Queries {
	return &Queries{db: db}
}

func Prepare(ctx context.Context, db DBTX) (*Queries, error) {
	q := Queries{db: db}
	var err error
	if q.assessmentCreateStmt, err = db.PrepareContext(ctx, assessmentCreate); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentCreate: %w", err)
	}
	if q.assessmentDeleteStmt, err = db.PrepareContext(ctx, assessmentDelete); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentDelete: %w", err)
	}
	if q.assessmentGetStmt, err = db.PrepareContext(ctx, assessmentGet); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentGet: %w", err)
	}
	if q.assessmentGetOnTaxBillStmt, err = db.PrepareContext(ctx, assessmentGetOnTaxBill); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentGetOnTaxBill: %w", err)
	}
	if q.assessmentGetOwnersBasedOnRunStmt, err = db.PrepareContext(ctx, assessmentGetOwnersBasedOnRun); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentGetOwnersBasedOnRun: %w", err)
	}
	if q.assessmentListAscStmt, err = db.PrepareContext(ctx, assessmentListAsc); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentListAsc: %w", err)
	}
	if q.assessmentListDescStmt, err = db.PrepareContext(ctx, assessmentListDesc); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentListDesc: %w", err)
	}
	if q.assessmentsListOwnerStmt, err = db.PrepareContext(ctx, assessmentsListOwner); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentsListOwner: %w", err)
	}
	if q.assessmentsListOwnerAllStmt, err = db.PrepareContext(ctx, assessmentsListOwnerAll); err != nil {
		return nil, fmt.Errorf("error preparing query AssessmentsListOwnerAll: %w", err)
	}
	if q.decisionCreateStmt, err = db.PrepareContext(ctx, decisionCreate); err != nil {
		return nil, fmt.Errorf("error preparing query DecisionCreate: %w", err)
	}
	if q.decisionsBasedOnWozObjectStmt, err = db.PrepareContext(ctx, decisionsBasedOnWozObject); err != nil {
		return nil, fmt.Errorf("error preparing query DecisionsBasedOnWozObject: %w", err)
	}
	if q.ownerTaxBillListDescStmt, err = db.PrepareContext(ctx, ownerTaxBillListDesc); err != nil {
		return nil, fmt.Errorf("error preparing query OwnerTaxBillListDesc: %w", err)
	}
	if q.runCreateStmt, err = db.PrepareContext(ctx, runCreate); err != nil {
		return nil, fmt.Errorf("error preparing query RunCreate: %w", err)
	}
	if q.runGetStmt, err = db.PrepareContext(ctx, runGet); err != nil {
		return nil, fmt.Errorf("error preparing query RunGet: %w", err)
	}
	if q.runListAscStmt, err = db.PrepareContext(ctx, runListAsc); err != nil {
		return nil, fmt.Errorf("error preparing query RunListAsc: %w", err)
	}
	if q.runListDescStmt, err = db.PrepareContext(ctx, runListDesc); err != nil {
		return nil, fmt.Errorf("error preparing query RunListDesc: %w", err)
	}
	if q.runUpdateStmt, err = db.PrepareContext(ctx, runUpdate); err != nil {
		return nil, fmt.Errorf("error preparing query RunUpdate: %w", err)
	}
	if q.tariffCreateStmt, err = db.PrepareContext(ctx, tariffCreate); err != nil {
		return nil, fmt.Errorf("error preparing query TariffCreate: %w", err)
	}
	if q.tariffGetStmt, err = db.PrepareContext(ctx, tariffGet); err != nil {
		return nil, fmt.Errorf("error preparing query TariffGet: %w", err)
	}
	if q.tariffListStmt, err = db.PrepareContext(ctx, tariffList); err != nil {
		return nil, fmt.Errorf("error preparing query TariffList: %w", err)
	}
	if q.tariffListRunStmt, err = db.PrepareContext(ctx, tariffListRun); err != nil {
		return nil, fmt.Errorf("error preparing query TariffListRun: %w", err)
	}
	if q.taxBillAssessmentStmt, err = db.PrepareContext(ctx, taxBillAssessment); err != nil {
		return nil, fmt.Errorf("error preparing query TaxBillAssessment: %w", err)
	}
	if q.taxBillGetStmt, err = db.PrepareContext(ctx, taxBillGet); err != nil {
		return nil, fmt.Errorf("error preparing query TaxBillGet: %w", err)
	}
	if q.taxBillListAscStmt, err = db.PrepareContext(ctx, taxBillListAsc); err != nil {
		return nil, fmt.Errorf("error preparing query TaxBillListAsc: %w", err)
	}
	if q.taxBillListDescStmt, err = db.PrepareContext(ctx, taxBillListDesc); err != nil {
		return nil, fmt.Errorf("error preparing query TaxBillListDesc: %w", err)
	}
	if q.taxBillOwnerStmt, err = db.PrepareContext(ctx, taxBillOwner); err != nil {
		return nil, fmt.Errorf("error preparing query TaxBillOwner: %w", err)
	}
	if q.taxBillsCreateStmt, err = db.PrepareContext(ctx, taxBillsCreate); err != nil {
		return nil, fmt.Errorf("error preparing query TaxBillsCreate: %w", err)
	}
	return &q, nil
}

func (q *Queries) Close() error {
	var err error
	if q.assessmentCreateStmt != nil {
		if cerr := q.assessmentCreateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentCreateStmt: %w", cerr)
		}
	}
	if q.assessmentDeleteStmt != nil {
		if cerr := q.assessmentDeleteStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentDeleteStmt: %w", cerr)
		}
	}
	if q.assessmentGetStmt != nil {
		if cerr := q.assessmentGetStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentGetStmt: %w", cerr)
		}
	}
	if q.assessmentGetOnTaxBillStmt != nil {
		if cerr := q.assessmentGetOnTaxBillStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentGetOnTaxBillStmt: %w", cerr)
		}
	}
	if q.assessmentGetOwnersBasedOnRunStmt != nil {
		if cerr := q.assessmentGetOwnersBasedOnRunStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentGetOwnersBasedOnRunStmt: %w", cerr)
		}
	}
	if q.assessmentListAscStmt != nil {
		if cerr := q.assessmentListAscStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentListAscStmt: %w", cerr)
		}
	}
	if q.assessmentListDescStmt != nil {
		if cerr := q.assessmentListDescStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentListDescStmt: %w", cerr)
		}
	}
	if q.assessmentsListOwnerStmt != nil {
		if cerr := q.assessmentsListOwnerStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentsListOwnerStmt: %w", cerr)
		}
	}
	if q.assessmentsListOwnerAllStmt != nil {
		if cerr := q.assessmentsListOwnerAllStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing assessmentsListOwnerAllStmt: %w", cerr)
		}
	}
	if q.decisionCreateStmt != nil {
		if cerr := q.decisionCreateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing decisionCreateStmt: %w", cerr)
		}
	}
	if q.decisionsBasedOnWozObjectStmt != nil {
		if cerr := q.decisionsBasedOnWozObjectStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing decisionsBasedOnWozObjectStmt: %w", cerr)
		}
	}
	if q.ownerTaxBillListDescStmt != nil {
		if cerr := q.ownerTaxBillListDescStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing ownerTaxBillListDescStmt: %w", cerr)
		}
	}
	if q.runCreateStmt != nil {
		if cerr := q.runCreateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing runCreateStmt: %w", cerr)
		}
	}
	if q.runGetStmt != nil {
		if cerr := q.runGetStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing runGetStmt: %w", cerr)
		}
	}
	if q.runListAscStmt != nil {
		if cerr := q.runListAscStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing runListAscStmt: %w", cerr)
		}
	}
	if q.runListDescStmt != nil {
		if cerr := q.runListDescStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing runListDescStmt: %w", cerr)
		}
	}
	if q.runUpdateStmt != nil {
		if cerr := q.runUpdateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing runUpdateStmt: %w", cerr)
		}
	}
	if q.tariffCreateStmt != nil {
		if cerr := q.tariffCreateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing tariffCreateStmt: %w", cerr)
		}
	}
	if q.tariffGetStmt != nil {
		if cerr := q.tariffGetStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing tariffGetStmt: %w", cerr)
		}
	}
	if q.tariffListStmt != nil {
		if cerr := q.tariffListStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing tariffListStmt: %w", cerr)
		}
	}
	if q.tariffListRunStmt != nil {
		if cerr := q.tariffListRunStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing tariffListRunStmt: %w", cerr)
		}
	}
	if q.taxBillAssessmentStmt != nil {
		if cerr := q.taxBillAssessmentStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing taxBillAssessmentStmt: %w", cerr)
		}
	}
	if q.taxBillGetStmt != nil {
		if cerr := q.taxBillGetStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing taxBillGetStmt: %w", cerr)
		}
	}
	if q.taxBillListAscStmt != nil {
		if cerr := q.taxBillListAscStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing taxBillListAscStmt: %w", cerr)
		}
	}
	if q.taxBillListDescStmt != nil {
		if cerr := q.taxBillListDescStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing taxBillListDescStmt: %w", cerr)
		}
	}
	if q.taxBillOwnerStmt != nil {
		if cerr := q.taxBillOwnerStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing taxBillOwnerStmt: %w", cerr)
		}
	}
	if q.taxBillsCreateStmt != nil {
		if cerr := q.taxBillsCreateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing taxBillsCreateStmt: %w", cerr)
		}
	}
	return err
}

func (q *Queries) exec(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (sql.Result, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).ExecContext(ctx, args...)
	case stmt != nil:
		return stmt.ExecContext(ctx, args...)
	default:
		return q.db.ExecContext(ctx, query, args...)
	}
}

func (q *Queries) query(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (*sql.Rows, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryContext(ctx, args...)
	default:
		return q.db.QueryContext(ctx, query, args...)
	}
}

func (q *Queries) queryRow(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) *sql.Row {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryRowContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryRowContext(ctx, args...)
	default:
		return q.db.QueryRowContext(ctx, query, args...)
	}
}

type Queries struct {
	db                                DBTX
	tx                                *sql.Tx
	assessmentCreateStmt              *sql.Stmt
	assessmentDeleteStmt              *sql.Stmt
	assessmentGetStmt                 *sql.Stmt
	assessmentGetOnTaxBillStmt        *sql.Stmt
	assessmentGetOwnersBasedOnRunStmt *sql.Stmt
	assessmentListAscStmt             *sql.Stmt
	assessmentListDescStmt            *sql.Stmt
	assessmentsListOwnerStmt          *sql.Stmt
	assessmentsListOwnerAllStmt       *sql.Stmt
	decisionCreateStmt                *sql.Stmt
	decisionsBasedOnWozObjectStmt     *sql.Stmt
	ownerTaxBillListDescStmt          *sql.Stmt
	runCreateStmt                     *sql.Stmt
	runGetStmt                        *sql.Stmt
	runListAscStmt                    *sql.Stmt
	runListDescStmt                   *sql.Stmt
	runUpdateStmt                     *sql.Stmt
	tariffCreateStmt                  *sql.Stmt
	tariffGetStmt                     *sql.Stmt
	tariffListStmt                    *sql.Stmt
	tariffListRunStmt                 *sql.Stmt
	taxBillAssessmentStmt             *sql.Stmt
	taxBillGetStmt                    *sql.Stmt
	taxBillListAscStmt                *sql.Stmt
	taxBillListDescStmt               *sql.Stmt
	taxBillOwnerStmt                  *sql.Stmt
	taxBillsCreateStmt                *sql.Stmt
}

func (q *Queries) WithTx(tx *sql.Tx) *Queries {
	return &Queries{
		db:                                tx,
		tx:                                tx,
		assessmentCreateStmt:              q.assessmentCreateStmt,
		assessmentDeleteStmt:              q.assessmentDeleteStmt,
		assessmentGetStmt:                 q.assessmentGetStmt,
		assessmentGetOnTaxBillStmt:        q.assessmentGetOnTaxBillStmt,
		assessmentGetOwnersBasedOnRunStmt: q.assessmentGetOwnersBasedOnRunStmt,
		assessmentListAscStmt:             q.assessmentListAscStmt,
		assessmentListDescStmt:            q.assessmentListDescStmt,
		assessmentsListOwnerStmt:          q.assessmentsListOwnerStmt,
		assessmentsListOwnerAllStmt:       q.assessmentsListOwnerAllStmt,
		decisionCreateStmt:                q.decisionCreateStmt,
		decisionsBasedOnWozObjectStmt:     q.decisionsBasedOnWozObjectStmt,
		ownerTaxBillListDescStmt:          q.ownerTaxBillListDescStmt,
		runCreateStmt:                     q.runCreateStmt,
		runGetStmt:                        q.runGetStmt,
		runListAscStmt:                    q.runListAscStmt,
		runListDescStmt:                   q.runListDescStmt,
		runUpdateStmt:                     q.runUpdateStmt,
		tariffCreateStmt:                  q.tariffCreateStmt,
		tariffGetStmt:                     q.tariffGetStmt,
		tariffListStmt:                    q.tariffListStmt,
		tariffListRunStmt:                 q.tariffListRunStmt,
		taxBillAssessmentStmt:             q.taxBillAssessmentStmt,
		taxBillGetStmt:                    q.taxBillGetStmt,
		taxBillListAscStmt:                q.taxBillListAscStmt,
		taxBillListDescStmt:               q.taxBillListDescStmt,
		taxBillOwnerStmt:                  q.taxBillOwnerStmt,
		taxBillsCreateStmt:                q.taxBillsCreateStmt,
	}
}
